unit uFenster;
(* ******************************************************************** *)
(* K L A S S E :  FENSTER - TableCuenta                                 *)
(* -------------------------------------------------------------------- *)
(* Version     :  1.81                                                  *)
(* Autor       :  Ronnie Hpfner, Boris Mller-Rowold                   *)
(*                                                                      *)
(* Aufgabe     : uebernimmt E/A und steuert die Funktionen ueber ein GUI*)
(* Compiler    : DELPHI 4.0                                             *)
(* Aenderung   : V. 1.x - 28-SEP-00                                     *)
(*                        29.12.00  - Groesse angepasst, zentriert,     *)
(*                                    Infobox, Dateiname : uFenster     *)
(* ******************************************************************** *)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, Tabnotbk, jpeg, ExtCtrls, StdCtrls, Buttons, Mask,
  //Spin,
  uSpeisekarte,
  uArtikel,
  uKellner,
  uKellnerliste,
  uBestellposition,
  uBestellung,
  uRechnung,
  uInfoBox;


type
  TTablecuentaFrm = class(TForm)
    hilfePnl          : TPanel;
    EndeSBtn          : TSpeedButton;

    GesamtPgeControll : TPageControl;
    BestellTabSheet   : TTabSheet;
    RechnungTabSheet  : TTabSheet;
    SpeisekarteTSheet : TTabSheet;
    KellnerlisteTabSheet: TTabSheet;
    TagesabrechnungTabSheet: TTabSheet;



    bestbeschr1Lbl    : TLabel;
    bestPreis1Lbl     : TLabel;
    bestbeschr2Lbl    : TLabel;
    bestPreis2Lbl     : TLabel;
    eintragSBtn       : TSpeedButton;
    BestlisteLb       : TListBox;
    BestNr2NrEdt      : TEdit;
    GroupBox1         : TGroupBox;

    gerichtnummerGb: TGroupBox;
    gerichtnummerEdt: TEdit;
    GerichtBeschrGb: TGroupBox;
    BeschreibungEdt: TEdit;
    gerichtPreisGb: TGroupBox;
    PreisEdt: TEdit;
    SpeisekarteLb: TListBox;

    KellnerNrGb: TGroupBox;
    NeuKellnerNrSBtn: TMaskEdit;
    KellnernameGb: TGroupBox;
    KellNameEdt: TEdit;
    kellnerlisteLb: TListBox;

    TagesRg: TRadioGroup;
    TaEingabeGb: TGroupBox;
    TakellNrLbl: TLabel;
    TaOK: TSpeedButton;
    AbrechnungsPnl: TPanel;
    Label1: TLabel;
    TarechanzeigenSBtn: TSpeedButton;
    TakellEinameLbl: TLabel;
    TakellnamePnl: TPanel;
    TaanzahlRechnPnl: TPanel;
    TaeinamePnl: TPanel;
    TaKellNrEdt: TEdit;
    ListBox1: TListBox;
    TalistbeschriftungLbl: TLabel;
    TaAnzahlLbl: TLabel;
    TaGesPreisPnl: TPanel;

    RechOKSBtn: TSpeedButton;
    DruckenSBtn: TSpeedButton;
    StornierenSBtn: TSpeedButton;
    RechLBox: TListBox;
    RechnungsGb: TGroupBox;
    RechPlatzEdt: TEdit;
    RechTischEdt: TEdit;

    Label2: TLabel;
    Label3: TLabel;

    bestkellnerEdt: TEdit;
    bestKellnerNr: TLabel;
    tischLbl: TLabel;
    tischnummerEdt: TEdit;
    Platzlbl: TLabel;
    PlatzEdt: TEdit;

    SpeiseOkSBtn: TSpeedButton;
    NeuSBtn: TSpeedButton;
    SpeiseaendSBtn: TSpeedButton;
    SpeiseloeschSBtn: TSpeedButton;
    SpeiseSuchSBtn: TSpeedButton;
    RueckBtn: TButton;
    VorBtn: TButton;

    kellOkSBtn: TSpeedButton;
    KellHinzuSBtn: TSpeedButton;
    KellAendSBtn: TSpeedButton;
    KellLoeschSBtn: TSpeedButton;
    KellSuchSBtn: TSpeedButton;

    LogoTabSheet: TTabSheet;
    Logoimage: TImage;
    BestellungGb: TGroupBox;
    BestNr1Lbl: TLabel;
    TeilnehmerLbl: TLabel;

    procedure EndeSBtnClick(Sender: TObject);
    procedure NeuSBtnClick(Sender: TObject);
    procedure SpeiseaendSBtnClick(Sender: TObject);
    procedure SpeiseloeschSBtnClick(Sender: TObject);
    procedure SpeiseOkSBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);

    procedure RueckBtnClick(Sender: TObject);
    procedure VorBtnClick(Sender: TObject);
    procedure SpeiseSuchSBtnClick(Sender: TObject);
    procedure SpeisekarteLbMouseDown(Sender: TObject; Button: TMouseButton;
                                      Shift: TShiftState; X, Y: Integer);
    procedure TeilnehmerLblClick(Sender: TObject);

 private

    procedure init;
    procedure BoxAktualisieren;
    procedure Datenaktualisieren(var Artikel:TArtikel);
    procedure MaskeAktualisieren(Artikel:TArtikel);

end;

(* ENDEBTN ************************************************************** *)
(*  Aufgabe :  <===== exakte textuelle Spezifikation alle gui-komponenten *)
(*  vorher:                                                               *)
(*  nachher:                                                              *)
(* ************************************************************************)

var
  TablecuentaFrm: TTablecuentaFrm;

implementation
{$R *.DFM}

////////////////////////////////////
// private Funktionen  //
////////////////////////////////////

var
  Speisekarte : TSpeisekarte;
  Artikel : TArtikel;

procedure TTablecuentaFrm.FormCreate(Sender: TObject);
(* -------------------------------------------------------------------- *)
begin
  TablecuentaFrm.Init;
  Artikel      := TArtikel.Create;
  speisekarte := TSpeisekarte.Create;
  speisekarte.Load('Artikel.dat');
  hilfePnl.Caption := ' Es wurden '+inttostr(speisekarte.GetLen) +  ' Datenstze geladen ';
  BoxAktualisieren;
end;

procedure TTablecuentaFrm.Init;
(* -------------------------------------------------------------------- *)
begin
  TablecuentaFrm.Caption := ' TabelCuenta - Testumgebung   OSZ-SchrottSoft ';
  hilfePnl.Caption    := '';
  SpeiseaendSBtn.Enabled  := true;
  SpeiseloeschSBtn.Enabled   := true;
  SpeiseOKSBtn.Enabled       := true;
  gerichtnummerEdt.Text          := '';
  BeschreibungEdt.Text := '';
  PreisEdt.Text       := '';
end;

procedure TTablecuentaFrm.EndeSBtnClick(Sender: TObject);
(* -------------------------------------------------------------------- *)
begin
  speisekarte.Store('artikel.dat');
  speisekarte.Free;
  Close;
end;

procedure TTablecuentaFrm.SpeiseOkSBtnClick(Sender: TObject);
(* -------------------------------------------------------------------- *)
var NeuerArtikel : TArtikel;
begin
  if speisekarte.IsFull
  then hilfePnl.Caption := ' Liste ist voll. Eintrge nicht gespeichert'
  else
    begin
      if BeschreibungEdt.Text <> ''
      then
        begin
          NeuerArtikel := TArtikel.Create;
          Datenaktualisieren (NeuerArtikel);
          speisekarte.Append (NeuerArtikel);
          Init;
        end
      else
        begin
          hilfePnl.Caption := ' Keine Eintrge - nicht gespeichert';
        end;
    end;
    BoxAktualisieren;
end;



procedure TTablecuentaFrm.DatenAktualisieren (var Artikel:TArtikel);
(* -------------------------------------------------------------------- *)
begin
    Artikel.SetNummer (strtoint(gerichtnummerEdt.Text));
    Artikel.SetBezeichnung (BeschreibungEdt.Text);
    Artikel.SetPreis (strtofloat(PreisEdt.Text));
end;

procedure TTablecuentaFrm.MaskeAktualisieren(Artikel:TArtikel);
(* ------------------------------------------------------------------- *)
begin
  begin
    gerichtnummerEdt.Text  := inttostr(Artikel.GetNummer);
    BeschreibungEdt.Text := Artikel.GetBezeichnung ;
    PreisEdt.Text  := floattostr(Artikel.GetPreis);
  end;
end;

procedure TTablecuentaFrm.BoxAktualisieren;
(* -------------------------------------------------------------------- *)
var Zeile : string;
begin
  speisekarte.Sort;
  SpeisekarteLb.Clear;
  zeile := '';
  speisekarte.First;
  while NOT speisekarte.EoList do
  begin
    Artikel := speisekarte.GetElement;
    zeile := Format('%-12d  %-43s  %-m',
     [Artikel.GetNummer,Artikel.GetBezeichnung,Artikel.Getpreis]);

    SpeisekarteLb.Items.Add(zeile);
    speisekarte.Next;
   end;
end;


procedure TTablecuentaFrm.RueckBtnClick(Sender: TObject);
(* -------------------------------------------------------------------- *)
begin
  Init;
  hilfePnl.Caption := '';

  if speisekarte.IsEmpty
  then  hilfePnl.Caption := ' Keine Eintrge vorhanden'
  else
    begin
      SpeiseaendsBtn.Enabled := true;
      SpeiseLoeschSBtn.Enabled  := true;

      if speisekarte.IsFirst
      then
        begin
          hilfePnl.Caption := ' Listenanfang ';
          Beep;
        end
      else speisekarte.Previous;
      Artikel := speisekarte.GetElement;
      MaskeAktualisieren(Artikel);
      SpeisekarteLb.Itemindex := speisekarte.GetAktuellePos -1;
    end;
end;


procedure TTablecuentaFrm.NeuSBtnClick(Sender: TObject);
(* -------------------------------------------------------------------- *)
begin
  Init;
  Caption           := ' speisekarte    -   Neue Eingaben';
  SpeiseOKSBtn.Enabled     := true;
  gerichtnummerEdt.Text :='';
  BeschreibungEdt.Text :='';
  preisEdt.Text :='';
end;

procedure TTablecuentaFrm.SpeiseLoeschSBtnClick(Sender: TObject);
(* -------------------------------------------------------------------- *)
var AbfrageErgebnis : integer;
begin
  if speisekarte.IsEmpty
  then hilfePnl.Caption := ' Keine Eintrge vorhanden'
  else
    begin
      beep;
      AbfrageErgebnis := Application.MessageBox('Wollen Sie wirklich lschen ?', '',MB_ICONWARNING + MB_YESNO);
      case AbfrageErgebnis of
        IDYES : begin
                  speisekarte.Remove;
                  Init;
                end;
      end;
      BoxAktualisieren ;
    end;
end;


procedure TTablecuentaFrm.SpeiseAendSBtnClick(Sender: TObject);
var AbfrageErgebnis : integer;
begin
  if speisekarte.IsEmpty
  then hilfePnl.Caption := ' Keine Eintrge vorhanden'
  else
    begin
      beep;
      AbfrageErgebnis := Application.MessageBox('Wollen Sie wirklich lschen ?', '',MB_ICONWARNING + MB_YESNO);
      case AbfrageErgebnis of
        IDYES : begin
           Datenaktualisieren (Artikel);
           speisekarte.PutElement(Artikel);
           BoxAktualisieren;
                 end;
           end;
    end;
end;

procedure TTablecuentaFrm.VorBtnClick(Sender: TObject);
(* -------------------------------------------------------------------- *)
begin
  Init;
  hilfePnl.Caption := '';

  if speisekarte.IsEmpty
  then hilfePnl.Caption := ' Keine Eintrge vorhanden'
  else
   begin
     SpeiseAendSBtn.Enabled := true;
     SpeiseLoeschSBtn.Enabled  := true;

     if speisekarte.IsLast
     then
       begin
        hilfePnl.Caption := ' Listenende';
        Beep;
       end
     else speisekarte.Next;
     Artikel := speisekarte.GetElement;
     MaskeAktualisieren (Artikel);
     SpeisekarteLb.Itemindex := speisekarte.GetAktuellePos -1;
   end;
end;

procedure TTablecuentaFrm.SpeiseSuchSBtnClick(Sender: TObject);
(* -------------------------------------------------------------------- *)
var
Artikel:TArtikel ;
begin
  Caption           := ' suchen -  einzeln anzeigen';
  SpeiseOKSBtn.Enabled     := false;
  PreisEdt.Text       := '0';

  Artikel := TArtikel.Create;
  DatenAktualisieren(Artikel);
  Artikel := speisekarte.SearchElement(artikel.GetNummer);

  if Artikel <> NIL
  then
    begin
      MaskeAktualisieren(Artikel);
      SpeisekarteLb.Itemindex := speisekarte.GetAktuellePos -1;
      SpeiseAendSBtn.Enabled := true;
      SpeiseLoeschSbtn.Enabled  := true;
    end
  else
    begin
      hilfePnl.Caption := ' Nicht gefunden !';
      SpeiseAendSBtn.Enabled := false;
      SpeiseLoeschSbtn.Enabled  := false;
    end;
end;

procedure TTablecuentaFrm.SpeisekarteLbMouseDown(Sender: TObject;
                    Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
(* -------------------------------------------------------------------- *)
var
  i :integer;
begin
  SpeiseOKSBtn.Enabled := false;
  speisekarte.First;
  for i := 1 to SpeisekarteLb.ItemIndex do speisekarte.Next;
  Artikel := speisekarte.GetElement;

  if Artikel <> NIL
  then
  begin
  MaskeAktualisieren(Artikel);
  SpeiseAendSBtn.Enabled := true;
  SpeiseLoeschSbtn.Enabled  := true;
  SpeisekarteLb.Itemindex := speisekarte.GetAktuellePos -1;
  end;
end;

procedure TTablecuentaFrm.TeilnehmerLblClick(Sender: TObject);
(* -------------------------------------------------------------------- *)
begin
  Infobox.Show
end;

end.
